﻿using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.EvolutionaryTracking {
  [Item("Generic wrapper", "Wrapper class for non-item HeuristicLab objects")]
  [StorableClass]
  public class GenericWrapper<T> : NamedItem where T : class {
    public T Content { get; private set; }

    private GenericWrapper() {
    }

    public GenericWrapper(T content) {
      Content = content;
    }

    [StorableConstructor]
    protected GenericWrapper(bool serializing)
      : base(serializing) {
    }

    private GenericWrapper(GenericWrapper<T> original, Cloner cloner)
      : base(original, cloner) {
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new GenericWrapper<T>(this, cloner);
    }
  }
}
